=== sysdeps/sparc/sparc64/fpu/multiarch/Makefile ===
ifeq ($(subdir),math)
ifeq ($(have-as-vis3),yes)
libm-sysdep_routines += m_signbitf-vis3 m_signbit-vis3 m_finitef-vis3 \
			m_finite-vis3 m_isinff-vis3 m_isinf-vis3 \
			m_isnanf-vis3 m_isnan-vis3 s_lrintf-vis3 \
			s_lrint-vis3 s_rintf-vis3 s_rint-vis3 \
			s_fminf-vis3 s_fmin-vis3 s_fmaxf-vis3 \
			s_fmax-vis3 s_fmaf-vis3 s_fma-vis3 \
			s_nearbyint-vis3 s_nearbyintf-vis3
sysdep_routines += s_signbitf-vis3 s_signbit-vis3 s_finitef-vis3 \
		   s_finite-vis3 s_isinff-vis3 s_isinf-vis3 \
		   s_isnanf-vis3 s_isnan-vis3
endif
endif
