=== sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/Makefile ===
ifeq ($(subdir),math)
ifeq ($(have-as-vis3),yes)
libm-sysdep_routines += m_copysignf-vis3 m_copysign-vis3 s_fabs-vis3 \
			s_fabsf-vis3 s_llrintf-vis3 s_llrint-vis3 \
			s_rintf-vis3 s_rint-vis3 w_sqrt-vis3 w_sqrtf-vis3 \
			s_fminf-vis3 s_fmin-vis3 s_fmaxf-vis3 s_fmax-vis3 \
			s_fmaf-vis3 s_fma-vis3 s_fdimf-vis3 s_fdim-vis3 \
			s_nearbyint-vis3 s_nearbyintf-vis3
sysdep_routines += s_copysignf-vis3 s_copysign-vis3
endif
endif
