=== debian/changelog ===
glibc (2.24-11+deb9u4) stretch; urgency=medium

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix buffer overflow in glob with GLOB_TILDE (CVE-2017-15670).  Closes:
      #879501.
    - Fix memory leak in glob with GLOB_TILDE (CVE-2017-15671).  Closes:
      #879500.
    - Fix a buffer overflow in glob with GLOB_TILDE in unescaping
      (CVE-2017-15804).  Closes: #879955.
    - Fix a memory leak in ld.so (CVE-2017-1000408).  Closes: #884132.
    - Fix a buffer overflow in ld.so (CVE-2017-1000409).  Closes: #884133.
    - Fixes incorrect RPATH/RUNPATH handling for SUID binaries
      (CVE-2017-16997).  Closes: #884615.
    - Fix a data corruption in SSE2-optimized memmove implementation for
      i386 (CVE-2017-18269).
    - Fix a stack-based buffer overflow in the realpath function
      (CVE-2018-11236).  Closes: #899071.
    - Fix a buffer overflow in the AVX-512-optimized implementation of the
      mempcpy function (CVE-2018-11237).  Closes: #899070.
    - Fix stack guard size accounting and reduce stack usage during
      unwinding to avoid segmentation faults on CPUs with AVX512-F.  Closes:
      #903554.
    - Fix a use after free in pthread_create().  Closes: #916925.
  * debian/debhelper.in/libc.postinst, script.in/nsscheck.sh: check for
    postgresql in NSS check.  Closes: #710275.

  [ Sebastian Andrzej Siewior ]
  * patches/any/local-condvar-do-not-use-requeue-for-pshared-condvars.patch:
    patch to fix pthread_cond_wait() in the pshared case on non-x86.  Closes:
    #904158.

 -- Aurelien Jarno <aurel32@debian.org>  Wed, 06 Feb 2019 22:17:41 +0100

glibc (2.24-11+deb9u3) stretch; urgency=medium

  [ Aurelien Jarno ]
  * debian/rules.d/debhelper.mk: install the libc-otherbuild postinst and
    postrm in the libc6-i686 transitional package, to make sure
    /etc/ld.so.nohwcap is correctly removed after an upgrade.  Closes:
    #883394.

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 14 Jan 2018 11:39:44 +0100

glibc (2.24-11+deb9u2) stretch; urgency=medium

  [ Aurelien Jarno ]
  * debian/control.in/x32: Add a gcc-multilib Recommends for libc6-dev-x32.
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - debian/patches/any/submitted-perl-inc.diff: drop, merged upstream.
    - debian/patches/any/cvs-remove-pid-tid-cache-clone.diff: drop, merged
      upstream.
    - debian/patches/any/local-CVE-2017-1000366-rtld-LD_LIBRARY_PATH.diff:
      drop, merged upstream.
    - debian/patches/any/local-CVE-2017-1000366-rtld-LD_PRELOAD.diff: drop,
      merged upstream.
    - debian/patches/any/local-CVE-2017-1000366-rtld-LD_AUDIT.diff: drop,
      merged upstream.
    - debian/patches/any/cvs-vectorized-strcspn-guards.diff: drop, merged
      upstream.
    - debian/patches/any/cvs-hwcap-AT_SECURE.diff: drop, merged upstream.
    - Avoid use-after-free read access in clntudp_call (CVE-2017-12133).
      Closes: #870648.
    - Fix compatibility with Intel C++ __regcall calling convention.  Closes:
      #881850.
    - Fix a buffer overrun in rpcgen.
    - Fix strlen on null pointer in nss_nisplus.
    - Fix invalid cast in group merging affecting ppc64 and s390x.
    - Define collation for Malayalam chillu characters.
    - Correct collation of U+0D36 and U+0D37 Malayalam characters.
  * debian/script.in/nohwcap.sh: always check for all optimized packages
    as multiarch allows one to install foreign architectures.  Closes:
    #882272.

  [ Santiago Vila ]
  * debian/debhelper.in/libc-bin.postinst: do not update /etc/nsswitch.conf
    when its content already matches the default.  Closes: #865144.

 -- Aurelien Jarno <aurel32@debian.org>  Fri, 01 Dec 2017 21:09:18 +0100

glibc (2.24-11+deb9u1) stretch-security; urgency=medium

  * debian/patches/any/local-CVE-2017-1000366-rtld-LD_AUDIT.diff,
    debian/patches/any/local-CVE-2017-1000366-rtld-LD_LIBRARY_PATH.diff,
    debian/patches/any/local-CVE-2017-1000366-rtld-LD_PRELOAD.diff: add
    patches to protect the dynamic linker against stack clashes
    (CVE-2017-1000366).
  * debian/patches/any/cvs-vectorized-strcspn-guards.diff: patch backported
    from upstream to allow usage of strcspn in ld.so.
  * debian/patches/any/cvs-hwcap-AT_SECURE.diff: patch backported from
    upstream to disable HWCAP for AT_SECURE programs.

 -- Aurelien Jarno <aurel32@debian.org>  Thu, 15 Jun 2017 21:17:14 +0200

glibc (2.24-11) unstable; urgency=medium

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Improve memcpy/memset performance on Skylake server.
  * debian/patches/any/cvs-malloc-hardening.diff: patch backported from
    upstream to further harden glibc malloc metadata against 1-byte
    overflows.  Closes: #862950.

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 28 May 2017 19:29:33 +0200

glibc (2.24-10) unstable; urgency=medium

  [ Samuel Thibault ]
  * hurd-i386/cvs-truncate64.diff: New patch to support 64bit truncate.
  * hurd-i386/cvs-send-recv-posix.diff: New patch to make send/recv more
    posix.

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix readahead on mips64el.
    - Improve branch predication in _dl_runtime_resolve_avx512_opt;
    - Fix symbol redirect for fts_set on 32-bit architectures.
    - Fix AVX2/AVX512 optimized unaligned memset.
    - Don't use PLT nor GOT in static archives on amd64.
    - Drop GLIBC_TUNABLES in setxid processes.
    - Fix write-after-destroy in lock elision on powerpc/ppc64el.
  * Drop patches/any/cvs-resolv-internal-qtype.diff, merged upstream.
  * any/cvs-remove-pid-tid-cache-clone.diff: patch from upstream to remove
    cached PID/TID in clone.  Closes: #857909.
  * debian/rules.d/build.mk: do not fail the build in case of testsuite
    regressions when building a +debXuX version. That way changes in the
    environment (e.g.: kernel) do not prevent security or stable versions
    to be built.


